<?php
















class PGTStorageFile extends PGTStorage
{
 




 





 var $_path;

 







 function getPath()
 {
 return $this->_path;
 }

 





 var $_format;

 






 function getFormat()
 {
 return $this->_format;
 }

 
 
 
 
 






 function getStorageType()
 {
 return "file";
 }

 






 function getStorageInfo()
 {
 return 'path=`'.$this->getPath().'\', format=`'.$this->getFormat().'\'';
 }

 
 
 
 
 








 function PGTStorageFile($cas_parent,$format,$path)
 {
 phpCAS::traceBegin();
 
 $this->PGTStorage($cas_parent);

 if (empty($format) ) $format = CAS_PGT_STORAGE_FILE_DEFAULT_FORMAT;
 if (empty($path) ) $path = CAS_PGT_STORAGE_FILE_DEFAULT_PATH;

 
 if (getenv("OS")=="Windows_NT"){
 
 if (!preg_match('`^[a-zA-Z]:`', $path)) {
 phpCAS::error('an absolute path is needed for PGT storage to file');
 }
 
 }
 else
 {
 
 if ( $path[0] != '/' ) {
 phpCAS::error('an absolute path is needed for PGT storage to file');
 }

 
 $path = preg_replace('|[/]*$|','/',$path);
 $path = preg_replace('|^[/]*|','/',$path);
 }
 
 $this->_path = $path;
 
 switch ($format) {
 case CAS_PGT_STORAGE_FILE_FORMAT_PLAIN:
 case CAS_PGT_STORAGE_FILE_FORMAT_XML:
 $this->_format = $format;
 break;
 default:
 phpCAS::error('unknown PGT file storage format (`'.CAS_PGT_STORAGE_FILE_FORMAT_PLAIN.'\' and `'.CAS_PGT_STORAGE_FILE_FORMAT_XML.'\' allowed)');
 }
 phpCAS::traceEnd(); 
 }

 
 
 
 
 




 function init()
 {
 phpCAS::traceBegin();
 
 if ( $this->isInitialized() )
 return;
 
 parent::init();
 phpCAS::traceEnd(); 
 }

 
 
 

 







 function getPGTIouFilename($pgt_iou)
 {
 phpCAS::traceBegin();
 $filename = $this->getPath().$pgt_iou.'.'.$this->getFormat();
 phpCAS::traceEnd($filename);
 return $filename;
 }
 
 








 function write($pgt,$pgt_iou)
 {
 phpCAS::traceBegin();
 $fname = $this->getPGTIouFilename($pgt_iou);
 if ( $f=fopen($fname,"w") ) {
 if ( fputs($f,$pgt) === FALSE ) {
 phpCAS::error('could not write PGT to `'.$fname.'\'');
 }
 fclose($f);
 } else {
 phpCAS::error('could not open `'.$fname.'\'');
 }
 phpCAS::traceEnd(); 
 }

 









 function read($pgt_iou)
 {
 phpCAS::traceBegin();
 $pgt = FALSE;
 $fname = $this->getPGTIouFilename($pgt_iou);
 if ( !($f=fopen($fname,"r")) ) {
 phpCAS::trace('could not open `'.$fname.'\'');
 } else {
 if ( ($pgt=fgets($f)) === FALSE ) {
 phpCAS::trace('could not read PGT from `'.$fname.'\'');
 } 
 fclose($f);
 }

 
 @unlink($fname);

 phpCAS::traceEnd($pgt);
 return $pgt;
 }
 
 
 
}

 
?>