<?php

function unhtmlentities ($string)
{
 $trans_tbl = get_html_translation_table (HTML_ENTITIES);
 $trans_tbl = array_flip ($trans_tbl);
 
 $trans_tbl["&nbsp;"] = " ";
 return strtr ($string, $trans_tbl);
}

function to_utf8( $string )
{
 global $FEATURE;
 if ( $FEATURE["UTF8"] ) 
 return utf8_encode( $string );
 else
 return $string;
}


function htmlentities_utf8( $string )
{
 global $FEATURE;
 if ( $FEATURE["UTF8"] ) 
 return htmlentities( $string, ENT_QUOTES, "UTF-8" );
 else
 return htmlentities($string);
}

function escape_decode($txt) {
 $txt = ereg_replace('%u([[:alnum:]]{4})', '&#x\1;',$txt);
 $ret = "";
 $old_pos = 0;
 while ( ($pos=strpos($txt, "%", $old_pos)) !== false )
 {
 $ret .= substr( $txt, $old_pos, $pos-$old_pos );
 $ret .= chr( hexdec(substr( $txt, $pos+1, 2 )) );
 $old_pos = $pos + 3;
 }
 $ret .= substr( $txt, $old_pos );
 return $ret;
}

?>
