<?
function tag_loadform($id,$type,$parts=false) {
 global $onoff, $FEATURE, $TAG_PREFIX, $TAG_FORMAT, $displayvelocityhelp, $NODE_ID;

 if (!$id) return false;

 if ($type == "template" || $type == "content" || $type == "obj") {
 $sql = "SELECT enabled FROM ".sqlf_name($type)."tag WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 if ($rs["num"]) $onoff = $rs["arr"][0]["enabled"];
 else $onoff = 1;
 if ($onoff == 3) $onoff = 1;
 }

 $id = sqlf_tl_num($id);
 if ($type == "global")
 $sql = "SELECT value.value_text, value.value_ref, value.info, part.type_id, part.id, part.editable, globaltag.enabled
FROM value, part, globaltag WHERE globaltag.id = $id AND value.globaltag_id = $id AND value.part_id = part.id";
 else if ($type == "construct")
 $sql = "SELECT value.value_text, value.value_ref, value.info, part.type_id, part.id, part.editable, part.keyword
FROM value, part WHERE part.construct_id = $id AND value.part_id = part.id AND (value.contenttag_id = 0 AND value.templatetag_id = 0 and value.globaltag_id = 0 AND value.objtag_id = 0)";
 else if ($type == "template")
 $sql = "SELECT value.value_text, value.value_ref, value.info, part.type_id, part.id, part.editable, part.keyword, templatetag.enabled
FROM value, part, templatetag WHERE templatetag.id = $id AND value.templatetag_id = $id AND value.part_id = part.id";
 else if ($type == "content")
 $sql = "SELECT value.value_text, value.value_ref, value.info, part.type_id, part.id, part.editable, part.keyword, contenttag.enabled
FROM value, part, contenttag WHERE contenttag.id = $id AND value.contenttag_id = $id AND value.part_id = part.id";
 else if ($type == "obj")
 $sql = "SELECT value.value_text, value.value_ref, value.info, part.type_id, part.id, part.editable, part.keyword, objtag.enabled
FROM value, part, objtag WHERE objtag.id = $id AND value.objtag_id = $id AND value.part_id = part.id";
 else halt(7,"tag_loadform: no valid type specified: type($type)");

 if (is_array($parts)) $sql .= " AND part.id IN (".implode(",", sqlf_tl_num_array($parts)).")";
 if (!is_array($parts) || count($parts) > 0) $rs = query($sql);

 
 
 if (!$rs["arr"] && $type == "obj") {

 $constructSql = "SELECT construct_id FROM objtag WHERE id = $id";
 $constructResultSet = query($constructSql);

 if ($constructResultSet['arr'][0]['construct_id'] > 0) {
 $constructId = $constructResultSet['arr'][0]['construct_id'];

 $defaultForObjtagSql = "SELECT v.value_text, v.value_ref, v.info, p.type_id, p.id, p.editable, p.keyword " .
 "FROM value v, part p " .
 "WHERE (v.contenttag_id = 0 AND v.templatetag_id = 0 and v.globaltag_id = 0 AND v.objtag_id = 0) " .
 "AND p.id = v.part_id AND p.construct_id = $constructId";
 $rs = query($defaultForObjtagSql);
 }
 }

 if (!$rs["arr"]) {
 
 } else {
 if ($FEATURE['velocity_helplink']) {
 $partid = $rs['arr'][0]['id'];
 if ($partid) {
 $sql = "SELECT p2.id FROM part p INNER JOIN part p2 ON p.construct_id = p2.construct_id WHERE p.id = ".sqlf_tl_num($partid)." AND p2.type_id IN (33,34,35)";
 $helplinkrs = query($sql);
 if ($helplinkrs['num'] > 0) {
 $displayvelocityhelp = true;
 }
 }
 }
 
 

 
 
 while (list($key,$val) = each($rs["arr"])) {
 $type_id = $val["type_id"];
 $pid = $val["id"];
 $val_text = $val["value_text"];
 $val_ref = $val["value_ref"];
 $info = $val["info"];
 $keyword = $val["keyword"];
 $inlineeditable = $val["editable"] == 2 ? 1 : 0;
 
 if ($type_id == 1 || $type_id == 2 || $type_id == 3 || $type_id == 9 || $type_id == 10 || $type_id == 15 || $type_id == 16 || $type_id == 17 || $type_id == 21 || $type_id == 22 || $type_id == 26 || $type_id == 27 || $type_id == 36 || $type_id == 37) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 if (($type_id == 10 && $FEATURE["dhtml_texttags"]) || $type_id == 27) $$tmp = ereg_replace("<$TAG_PREFIX ([$TAG_FORMAT]*)>","&lt;$TAG_PREFIX \\1&gt;",$val_text);
 else $$tmp = $val_text;
 
 if ($FEATURE["live-br2nl"]
 && $inlineeditable
 && !in_array($type_id, array(3, 21, 36)) 
 ) {
 $$tmp = str_replace("<BR>", "\n", $$tmp);
 }

 }
 
 if ($type_id == 4) {
 
 
 $tmp = "p".$pid."_a";
 if ($val_ref == 0) {
 $val_ref = "";
 } else {
 $page = new CNPageObject($val_ref);
 $val_ref = $page->getLocalizedId($NODE_ID);
 }
 global $$tmp;
 $$tmp = $val_ref;

 
 $tmp = "p".$pid."_b";
 global $$tmp;
 $$tmp = $val_text;

 
 $tmp = "p".$pid."_c";
 global $$tmp;
 if ($info == 0) $info = "b";
 if ($info == 1) $info = "a";
 $$tmp = $info;
 }


 
 if ($type_id == 5) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 $$tmp = $val_ref;
 }

 
 if ($type_id == 6) {

 
 $tmp = "p".$pid."_a";
 if ($val_ref == 0) {
 $val_ref = "";
 } else {
 $image = new CNImageObject($val_ref);
 $val_ref = $image->getLocalizedId($NODE_ID);
 }
 global $$tmp;
 $$tmp = $val_ref;
 }

 

 
 if ($type_id == 8 || $type_id == 14 || $type_id == 38 ) {

 
 $tmp = "p".$pid."_a";
 if ($val_ref == 0) {
 $val_ref = "";
 } else {
 $file = new CNFileObject($val_ref);
 $val_ref = $file->getLocalizedId($NODE_ID);
 }
 global $$tmp;
 $$tmp = $val_ref;
 }
 
 
 if ($type_id == 13) {

 
 $tmp = "p".$pid."_b";
 global $$tmp;
 $$tmp = $val_text;
 $tmp = "p".$pid."_c";
 global $$tmp;
 $$tmp = $info;
 }


 
 if ($type_id == 25 || $type_id == 39) {
 $tmp = "p".$pid."_a";
 if ($val_ref == 0) {
 $val_ref = "";
 } else {
 $folder = new CNFolderObject($val_ref);
 $val_ref = $folder->getLocalizedId($NODE_ID);
 }
 global $$tmp;
 $$tmp = $val_ref;
 }

 
 if ($type_id == 11 || $type_id == 20) {
 
 if ($type_id == 11) {
 
 $page = new CNPageObject($info);
 $info = $page->getLocalizedId($NODE_ID);
 $localPage = new CNPageObject($info);

 
 if ($localPage->getID() != $page->getID()) {
 if ($val_text == 'p') {
 
 
 $rs1 = query("SELECT id FROM contenttag WHERE content_id = ".sql_num($localPage->getFieldValue("content_id")).
 " AND name = (SELECT name FROM contenttag WHERE id = ".sql_num($val_ref).")");
 if ($rs1["num"] > 0) {
 $val_ref = $rs1["arr"][0]["id"];
 }
 } else {
 
 
 $rs1 = query("SELECT id FROM templatetag WHERE template_id = ".sql_num($localPage->getFieldValue("template_id")).
 " AND name = (SELECT name FROM templatetag WHERE id = ".sql_num($val_ref).")");
 if ($rs1["num"] > 0) {
 $val_ref = $rs1["arr"][0]["id"];
 }
 }
 }
 } else {
 
 $template = new CNTemplateObject($info);
 $info = $template->getLocalizedId($NODE_ID);
 $localTemplate = new CNTemplateObject($info);

 
 if ($localTemplate->getID() != $template->getID()) {
 
 $rs1 = query("SELECT id FROM templatetag WHERE template_id = ".sql_num($localTemplate->getID()).
 " AND name = (SELECT name FROM templatetag WHERE id = ".sql_num($val_ref).")");
 if ($rs1["num"] > 0) {
 $val_ref = $rs1["arr"][0]["id"];
 }
 }
 }
 $tmp = "p".$pid."_a";
 global $$tmp;
 $$tmp = $val_text.$val_ref."-".$info;
 }

 
 if ($type_id == 15 || $type_id == 16 || $type_id == 17) {
 $tmp = "p".$pid."_b";
 global $$tmp;
 $$tmp = $info;
 }

 
 if ($type_id == 23) {
 $sql = "SELECT info_text FROM part where id = ".sqlf_tl_num($pid);
 $rss = query($sql);
 $info_text = $rss['arr'][0]['info_text'];
 if (strlen($info_text) > 0) $info_text = explode(';',$info_text);
 $val_text = explode(";",$val_text);
 $tmp = "p".$pid."_a";
 global $$tmp;
 if (strlen($info_text[0]) > 0 && $info_text[0] != 0) $$tmp = $info_text[0];
 else $$tmp = $val_text[0];
 $tmp = "p".$pid."_b";
 global $$tmp;
 if (strlen($info_text[1]) > 0 && $info_text[1] != 0) $$tmp = $info_text[1];
 else $$tmp = $val_text[1];
 $tmp = "p".$pid."_c";
 global $$tmp;
 if (strlen($info_text[2]) > 0 && $info_text[2] != 0) $$tmp = $info_text[2];
 else $$tmp = $info;
 }

 
 if ($type_id == 12) {
 $val_text = explode(";",$val_text);
 $tmp = "p".$pid."_a";
 global $$tmp;
 $$tmp = $val_text[0];
 $tmp = "p".$pid."_b";
 global $$tmp;
 $$tmp = $val_text[1];






 $sql = "SELECT th, td_f_even, td_f_odd, th_f, td_type, th_type, table_f FROM contenttable 
WHERE ".sqlf_name($type)."tag_id = ".sqlf_tl_num($id)." AND part_id = ".sqlf_tl_num($pid);
 $_rs = query($sql);
 if ($_rs["arr"]) {
 $row = $_rs["arr"][0];
 $tmp = "p".$pid."_c";
 global $$tmp;
 $$tmp = $row["th"];
 $tmp = "p".$pid."_d";
 global $$tmp;
 $$tmp = $row["td_type"];
 $tmp = "p".$pid."_e";
 global $$tmp;
 $$tmp = $row["th_type"];
 $tmp = "p".$pid."_f";
 global $$tmp;
 $$tmp = $row["td_f_even"];
 $tmp = "p".$pid."_g";
 global $$tmp;
 $$tmp = $row["td_f_odd"];
 $tmp = "p".$pid."_h";
 global $$tmp;
 $$tmp = $row["th_f"];
 $tmp = "p".$pid."_i";
 global $$tmp;
 $$tmp = $row["table_f"];
 } 
 }

 if ($type_id == 18 || $type_id == 19 || $type_id == 24) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 if ($type_id == 18) {
 $size["70"] = 0;
 $size["120"] = 1;
 $size["180"] = 2;
 }
 if ($type_id == 19) {
 $size["110"] = 0;
 $size["160"] = 1;
 $size["220"] = 2;
 }
 if ($type_id == 24) {
 $size["zellehell"] = "zellehell";
 $size["zelledunkel"] = "zelledunkel";
 $size["headernegativ"] = "headernegativ";
 $size[" "] = "farblos";
 }
 $$tmp = $size[$val_text];
 }

 if ($type_id == 29 || $type_id == 30) {
 $tmp = "p".$pid."_a";
 $session = $tmp."_SESSION";
 global $$tmp, $$keyword, $$session;
 if ( !is_array($$session) ) $$session = array();
 mysession_var_reg($session);
 if ($type_id == 30) $$tmp = explode("|-|",$val_text);
 else $$tmp = $val_text;
 ${$session}["sel"] = $$tmp;
 }

 if ($type_id == 31) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 $$tmp = $val_text;
 }
 
 if ( $type_id == 32 ) {
 $tmp = "p".$pid."_genDatasourceWizard";
 global $$tmp;
 $$tmp = $val_ref;
 $tmp = "p".$pid."_b";
 global $$tmp;
 $$tmp = $val_text;
 }

 }
 }
}
?>
