<?php


echo $fileUploader->getAssetsHtml();
?>

<div id="file_dialog" <?php if ($showMiniBrowser) { ?> style="width: 760px;"<?php } ?>>
	<div<?php if ($showMiniBrowser) { ?> style="width: 460px; float: left; overflow: hidden;"<?php } ?>>
<?php

echo $dialogOutput;
?>
	</div>

<?php
if ($showMiniBrowser) {
?>
	<div style="width: 300px; float: left;">
<?php
$htmlform->pstart();
echo dialog($miniTree->build_form(), "", "normal", i18n("cn_minibrowser"), $ICO_MINI);
$htmlform->pend();
?>
	</div>
<?php
}
?>
</div>

<div style="clear: both;"></div>

<script type="text/javascript">

// Whether to bypass the submit hook
var bypassSubmitHook = false;
var $okButton        = $("input[name=factionok]");
$okButton.attr("onclick", "");

/**
 * Called when a file was uploaded successfully without errors.
 *
 * @param {Object} file         Original plupload file
 * @param {Object} responseFile RestAPI response object
 */
function fileUploader_onSuccess(file, responseFile) {
	// Set the file ID
	$("input[name=f_fileid]").val(responseFile.id);
 
	// Update the corresponding information
	$(".dialog h1").first().text(responseFile.name);
	$("input[name=f_filename]").val(responseFile.name);
	$("#filesize").text(plupload.formatSize(responseFile.fileSize));

	$filetype = $(".dialog input[name=f_filetype]");
	if ($filetype.length > 0) {
		$filetype.val(responseFile.fileType);
	} else {
		$("#f_filetype").text(responseFile.fileType);
	}

	bypassSubmitHook = true;

	// Call the clientside validation function
	if (!check_gentics(true)) {
		restoreOkButton();
		return;
	}

	// Post the form
	$("input[name=factionok]").click();
}

/**
 * Called when an error occured during file upload.
 */
function fileUploader_onError() {
	restoreOkButton();
}

/**
 * Makes the OK-button clickable again.
 */
function restoreOkButton() {
	$okButton
		.css({ opacity: 1.0 })
		.attr("src", "?do=15&text=OK");
}

/**
 * Called when new files has been added to the queue.
 */
function fileUploader_onFilesAdded(files) {
	var file = files[0];

	// Update the filename
	$("input[name=f_filename]").val(file.name);

	// Update the filesize
	if (file.size !== null && file.size > 0) {
		$("#filesize").text(plupload.formatSize(file.size));
	} else {
		$("#filesize").text("-");
	}
}

/**
 * Called on enter and when "OK" is clicked.
 */
function file_onSubmit(event) {
	if (bypassSubmitHook) {
		bypassSubmitHook = false;
		return true;
	}

	// If there is a file in the queue, upload it first
	// and cancel this form
	if (fileUploader.startUpload() > 0) {
		// Change the opacity and the text of the button
		$okButton
			.css({ opacity: 0.5 })
			.attr("src", "?do=15&text=(Uploading...)")
			.attr("onclick", "");

		return false;
	}

	return true;
}

$(document).ready(function() {

	// This implements custom submit event
	// handling for the fileuploader

	// Unset all onclick attributes
	$("input")
		.removeAttr("onkeydown")
		.keydown(function(event) {
			if (event.which === 13) {
				return file_onSubmit(event);
			}
		}
	);

	$okButton
		.removeAttr("onkeydown")
		.click(function(event) {
			return file_onSubmit(event);
		}
	);
});

</script>
